﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WindowsFormsApplication1
{
    class Line : IShape
    {
        public Brush Fill { get; set; }
        public Pen Pen { get; set; }
        public PointF Start { get; set; }
        public PointF End { get; set; }

        public void Draw(Graphics g)
        {
            g.DrawLine(Pen, Start, End);
        }

        public bool IsHit(PointF p)
        {
            // Find distance to the end points
            var d1 = Math.Sqrt((Start.X - p.X) * (Start.X - p.X) + (Start.Y - p.Y) * (Start.Y - p.Y));
            var d2 = Math.Sqrt((End.X - p.X) * (End.X - p.X) + (End.Y - p.Y) * (End.Y - p.Y));

            // https://en.wikipedia.org/wiki/Distance_from_a_point_to_a_line
            var dx = End.X - Start.X;
            var dy = End.Y - Start.Y;
            var length = Math.Sqrt(dx * dx + dy * dy);
            var distance = Math.Abs(dy * p.X - dx * p.Y + End.X * Start.Y - End.Y * Start.X) / Math.Sqrt(dy * dy + dx * dx);

            // Make sure the click was really near the line because the distance above also works beyond the end points
            return distance < 3 && (d1 < length + 3 && d2 < length + 3);
        }
    }
}
